<template>
    <div class="flex items-center justify-between mb-4">
        <Breadcrumb nameRouteHome="teacher" textRouteHome="Trang chủ">
            <ItemBreadcrumb>Ngân hàng câu hỏi</ItemBreadcrumb>
        </Breadcrumb>
        <LinkButton nameRoute="teacher-quiz-create">
            <PlusCircleIcon class="text-white" />
            <span>Tạo câu hỏi</span>
        </LinkButton>
    </div>

    <div class="card">
        <div class="card-header border-b-none">
            <form
                @submit.prevent="submitSearchForm"
                class="flex items-end gap-3"
            >
                <div class="form-control">
                    <div>Từ khóa:</div>
                    <label for="name">
                        <input
                            v-model="name"
                            id="name"
                            type="text"
                            class="focus:border-main-color rounded-md border border-gray-200 text-sm mt-1 px-3 py-2"
                            placeholder="Từ khóa..."
                            autocomplete="off"
                        />
                    </label>
                </div>
                <div class="form-control">
                    <label for="category">
                        <div>Môn học:</div>
                        <select
                            v-model="category"
                            id="category"
                            class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                        >
                            <option
                                :key="category.id"
                                v-for="category in SELECT_OPTION_COURSE_CATEGORY"
                                :value="category.id"
                            >
                                {{ category.text }}
                            </option>
                        </select>
                    </label>
                </div>
                <BasicButton
                    type="submit"
                    classCustom="bg-color-warning hover:shadow-hover-warning"
                >
                    <SearchIcon class="text-white" />
                    <span>Tìm kiếm</span>
                </BasicButton>
            </form>
        </div>
        <table>
            <thead>
                <tr>
                    <th>Nội dung câu hỏi</th>
                    <th class="text-center">Môn học</th>
                    <th class="text-center">Loại câu hỏi</th>
                    <th class="text-center">Điểm</th>
                    <th>Thời gian tạo</th>
                    <th class="text-center">Hành động</th>
                </tr>
            </thead>
            <tbody>
                <template v-if="!isLoading">
                    <template v-if="quizzesComputed && quizzesComputed.length">
                        <tr :key="quiz.id" v-for="quiz in quizzesComputed">
                            <td v-html="quiz.name"></td>
                            <td class="text-center">
                                {{ quiz.course_category }}
                            </td>
                            <td class="text-center">
                                <span
                                    v-if="
                                        quiz.type_question ===
                                            TYPE_QUIZ_ONCE_RIGHT_ANSWER
                                    "
                                    class="bg-color-success text-white text-xs font-semibold rounded-2xl px-3 py-1"
                                >
                                    {{ quiz.type }}
                                </span>
                                <span
                                    v-else-if="
                                        quiz.type_question ===
                                            TYPE_QUIZ_MULTI_RIGHT_ANSWER
                                    "
                                    class="bg-color-primary text-white text-xs font-semibold rounded-2xl px-3 py-1"
                                >
                                    {{ quiz.type }}
                                </span>
                                <span
                                    v-else-if="
                                        quiz.type_question ===
                                            TYPE_QUIZ_TRUE_FALSE_ANSWER
                                    "
                                    class="bg-color-danger text-white text-xs font-semibold rounded-2xl px-3 py-1"
                                >
                                    {{ quiz.type }}
                                </span>
                            </td>
                            <td class="text-center">{{ quiz.mark }}₫</td>
                            <td>{{ quiz.created_at }}</td>
                            <td>
                                <div
                                    class="box-actions flex items-center justify-center gap-1"
                                >
                                    <router-link
                                        :to="{
                                            name: 'teacher-quiz-update',
                                            params: { quizId: quiz.id }
                                        }"
                                        v-tooltip="'Sửa'"
                                        class="action-edit"
                                    >
                                        <PencilIcon />
                                    </router-link>
                                    <div
                                        @click="onDelete(quiz.id)"
                                        v-tooltip="'Xóa'"
                                        class="cursor-pointer action-delete"
                                    >
                                        <TrashIcon />
                                    </div>
                                </div>
                            </td>
                        </tr>
                    </template>
                    <template v-else>
                        <tr class="no-data-table">
                            <td colspan="6" class="text-center">
                                Không có dữ liệu
                            </td>
                        </tr>
                    </template>
                </template>
                <template v-else>
                    <tr>
                        <td colspan="6" class="text-center">
                            <SpinLoading />
                        </td>
                    </tr>
                </template>
            </tbody>
        </table>
        <div
            v-if="!isLoading && quizzesComputed && quizzesComputed.length"
            class="flex justify-end p-6"
        >
            <BasicPagination
                @onClickPage="onClickPage"
                :currentPage="currentPage"
                :lastPage="lastPage"
            />
        </div>
    </div>
</template>

<script>
import { computed, ref, watch } from "vue";
import { useRoute, useRouter } from "vue-router";
import {
    COURSE_CATEGORY_ENGLISH,
    SELECT_OPTION_COURSE_CATEGORY,
    SELECT_TYPE_QUIZ,
    TYPE_QUIZ_ONCE_RIGHT_ANSWER,
    TYPE_QUIZ_MULTI_RIGHT_ANSWER,
    TYPE_QUIZ_TRUE_FALSE_ANSWER
} from "@/constants";
import timeHelper from "@/helper/timeHelper";
import Swal from "sweetalert2";
import { createToast } from "mosha-vue-toastify";

import useFetchAllQuiz from "@/hooks/quiz/useFetchAllQuiz";
import useDeleteQuiz from "@/hooks/quiz/useDeleteQuiz";

import {
    PlusCircleIcon,
    SearchIcon,
    PencilIcon,
    TrashIcon
} from "@heroicons/vue/outline";
import SpinLoading from "@/components/loading/SpinLoading.vue";
import Breadcrumb from "@/components/breadcrumb/Breadcrumb.vue";
import ItemBreadcrumb from "@/components/breadcrumb/ItemBreadcrumb.vue";
import BasicButton from "@/components/button/BasicButton.vue";
import LinkButton from "@/components/button/LinkButton.vue";
import BasicPagination from "@/components/pagination/BasicPagination.vue";

export default {
    components: {
        PlusCircleIcon,
        SearchIcon,
        PencilIcon,
        TrashIcon,
        SpinLoading,
        Breadcrumb,
        ItemBreadcrumb,
        BasicButton,
        LinkButton,
        BasicPagination
    },
    setup() {
        const route = useRoute();
        const router = useRouter();
        const quizzes = ref([]);
        const name = ref(route.query.name || null);
        const category = ref(route.query.category || COURSE_CATEGORY_ENGLISH);
        const { isLoading, listQuiz, onFetchAllQuiz } = useFetchAllQuiz();
        const { errorResponse, onDeleteQuiz } = useDeleteQuiz();

        async function onFetch() {
            await onFetchAllQuiz(category.value, route.query);
            quizzes.value = listQuiz.value;
        }
        onFetch();

        const quizzesComputed = computed(() => {
            if (quizzes.value && quizzes.value.length) {
                return quizzes.value.map(quiz => {
                    let course_category;
                    SELECT_OPTION_COURSE_CATEGORY.forEach(category => {
                        if (quiz.course_category_id === category.id)
                            course_category = category.text;
                    });
                    let type;
                    SELECT_TYPE_QUIZ.forEach(item => {
                        if (quiz.type_question === item.id) type = item.text;
                    });
                    return {
                        ...quiz,
                        course_category,
                        type,
                        created_at: timeHelper.getTimeString(
                            "H:i:s - d/m/Y",
                            timeHelper.getTimeInt(quiz.created_at)
                        )
                    };
                });
            } else {
                return [];
            }
        });

        // search
        async function submitSearchForm() {
            await onFetchAllQuiz(category.value, { name: name.value });
            quizzes.value = listQuiz.value;

            const path = route.path;

            let query = {};
            if (name.value) query = { ...query, name: name.value };
            if (category.value !== null && category.value !== "")
                query = { ...query, category: category.value };

            router.push({ path, query });
        }

        // update currentPge and lastPage when change listQuiz
        const currentPage = ref(1);
        const lastPage = ref(1);
        watch(listQuiz, newValue => {
            currentPage.value = newValue.current_page;
            lastPage.value = newValue.last_page;
        });

        // click pagination
        async function onClickPage(value) {
            router.push({
                path: route.path,
                query: { ...route.query, page: value }
            });

            await onFetchAllQuiz({ ...route.query, page: value });
            quizzes.value = listQuiz.value.data;
        }

        // deleteUser
        async function onDelete(id) {
            Swal.fire({
                icon: "question",
                title: `<span style="font-size: 23px;">Bạn có chắc muốn xóa câu hỏi này không?</span>`,
                confirmButtonText: "Xóa",
                showDenyButton: true,
                denyButtonText: "Hủy",
                focusConfirm: false
            }).then(async result => {
                if (result.isConfirmed) {
                    // show loading
                    document.getElementById("full-page-loading").style.display =
                        "block";

                    await onDeleteQuiz(id);

                    // hide loading
                    document.getElementById("full-page-loading").style.display =
                        "none";

                    // check error from server
                    if (errorResponse.value) {
                        createToast("Xóa thất bại, đã có lỗi xảy ra", {
                            showIcon: true,
                            type: "danger"
                        });
                    } else {
                        quizzes.value = quizzes.value.filter(quiz => {
                            return quiz.id != id;
                        });
                        createToast("Xóa thành công", {
                            showIcon: true,
                            type: "success"
                        });
                    }
                }
            });
        }

        return {
            SELECT_OPTION_COURSE_CATEGORY,
            TYPE_QUIZ_ONCE_RIGHT_ANSWER,
            TYPE_QUIZ_MULTI_RIGHT_ANSWER,
            TYPE_QUIZ_TRUE_FALSE_ANSWER,
            isLoading,
            quizzesComputed,
            name,
            category,
            submitSearchForm,
            currentPage,
            lastPage,
            onClickPage,
            onDelete
        };
    }
};
</script>
